
	.include    "jaguar.inc"
	.include    "graphics.inc"
  .include    "game68k.inc"
  
	.globl _font8x8_8b
	.globl _vidmem	
	.globl _tunnelmem	
	.globl _tunnelmem2
	.globl _scrollmap		
	.globl _lutdata
	.globl _lutleftdata
	.globl _lutrightdata
	.globl _pallutdata
	.globl _pallutleftdata
	.globl _pallutrightdata
	.globl _U235SElogo
	.globl _endbitmap
	.globl _module
	.globl _ingamemod1
	.globl _ingamemod2
	.globl _ingamemod3
	.globl _endmod
	.globl GameVideoIT
	.globl _masktunnel
	.globl _shipbitmap
	.globl _shipthrustoffbitmap
	.globl _shipkillbitmap
	
	.globl _titlebitmap
	.globl _menutiles
	.globl _menumap
	
; Tracks data
  .globl _systemtype
	.globl _tracks
	.globl _tracks_number
	
; Sounds 
  .globl  _jetsound
  .globl  _jetsoundend
  .globl  _crashsound
  .globl  _crashsoundend
  .globl  _jaguarsound
  .globl  _jaguarsoundend
  .globl  _electricsound
  .globl  _electricsoundend
  .globl  _blanksound
  .globl  _blanksoundend
  
; -------------------------------------------------------
; Externals
; -------------------------------------------------------	
	  .extern gpusem
    
    .extern gpuscrollmapbase
    .extern gpuLUTYoffset
    .extern gupptrvidmem
    
    .extern gputilemapptr
    .extern gputilesptr
    .extern _gpulinenumber
	  .extern _ActiveBitmapArray

	 .text
	 .68000


; -------------------------------------------------------
; Video Interrupt handler
; -------------------------------------------------------	

; ------------------------------------------------
; Game specific video interrupt routine
 
 
GameVideoIT:  
    movem.l  d0-d3/d7/a0/a1,-(sp)    
    move.w  INT1,d0
    btst.l  #1,d0
    beq.s     NotAGPUInterrupt
          
    move.w  #C_GPUCLR|C_VIDENA|C_GPUENA,INT1  ; clear GPU interrupt
    move.w  #$0,INT2
    movem.l  (sp)+,d0-d3/d7/a0/a1
    rte
    
NotAGPUInterrupt:   
    btst.l  #0,d0
    bne.s   VideoInterrupt
    
    ; We shouldn't get here...
    move.w  #C_GPUCLR|C_VIDENA|C_GPUENA,INT1  ; clear GPU interrupt
    move.w  #$0,INT2    
    movem.l  (sp)+,d0-d3/d7/a0/a1 
    rte
   
VideoInterrupt:       
    move.l  _ActiveBitmapArray,d0
    tst.l   d0
    beq    .NoBitmapArray
    
    move.l  d0,a1
    move.l  CBitmapArrayCount(a1),d7
    tst.w   d7
    beq    .NoBitmapArray
    subq.w  #1,d7  
    move.l  CBitmapArrayPt(a1),d0
    tst.l   d0
    beq    .NoBitmapArray
    move.l  d0,a1
    move.w  #$7FF,d2
    move.w  fby,d3
.loop:
    move.l  CBitmapPtDL(a1),a0
    move.l  CBitmapObj(a1),d0     ; 63 - 32
    andi.l  #$7FFF,d0           ; Clear DATA
    move.l  CBitmapAddr(a1),d1  ; Update DATA     
    lsl.l   #8,d1
    or.l    d1,d0    
    move.l  d0,(a0)   
    move.l  CBitmapObj+4(a1),d0   ; 31 - 0
    move.l  d0,4(a0)
    lea   CBitmapSz(a1),a1
    dbf    d7,.loop
	
    move.l  _ActiveBitmapArray,a1
		move.l  CBitmapArrayDL(a1),d0
		tst.l   d0
		beq.s   .NoBitmapArray
    move.l  d0,OLP
.NoBitmapArray: 
	  add.l	#1,_ticks		; Increment ticks semaphore   
	  move.w  #$FFFF,topvbl
   
; Clear video interupt
		move.w  #C_VIDCLR|C_VIDENA|C_GPUENA,INT1  
		move.w  #$0,INT2 
		movem.l  (sp)+,d0-d3/d7/a0/a1
		rte
    
; -------------------------------------------------------
; Graphic routines
; -------------------------------------------------------	
    
  .include "tiles.inc"

; ------------------------------------------------
; InitScrollMap (C interface)
; IN: (long) ptr to scrollmap
;     (long) ptr to bitmaps
;     (long) ptr to tilemap
_InitScrollMap::
      move.l  4(sp),a0  ; ptr to scrollmap  
      move.l  8(sp),a1  ; ptr to bitmaps
      move.l  12(sp),d0 ; ptr to tilemap
      movem.l d2-d6/a2-a3,-(sp)
      move.l  d0,a2   ; a2 points to tilemap
      
      ; Compute step
      move.l  #TILE_W,d0
      neg.w   d0
      andi.l  #$FFFF,d0
      ori.l   #1<<16,d0 
      move.l  d0,A1_STEP
      clr.l   d4   
      ; Set blitter flags    
      move.l  #PITCH1|PIXEL8|TILE_BW|XADDPHR,A2_FLAGS
      move.l  #PITCH1|PIXEL8|SCROLLMAPBW|XADDPHR,A1_FLAGS
      move.l  #(TILE_H<<16)|TILE_W,d1 
     
      move.l  #N_TILES_Y,d3      
      subq.l  #1,d3
.loopY:
        move.l  #N_TILES_X,d2
        subq.l  #1,d2
.loopX: 
          clr.l   d0
          move.b  (a2)+,d0
          lsl.l #TILE_SHW,d0     ; *32 (W)
          lsl.l #TILE_SHH,d0   ; *32 (H) 
          lea (a1,d0),a3  ; select tile         
          move.l  a3,A2_BASE
          move.l  a0,A1_BASE
          move.l  d4,A2_PIXEL  
          move.l  d4,A1_PIXEL
          move.l  d1,B_COUNT
          move.l  #SRCEN|LFU_REPLACE|UPDA1,B_CMD                  
          lea TILE_W(a0),a0
        dbf   d2,.loopX
        adda.l  #((SCROLLMAP_W*TILE_H)-SCROLLMAP_W),a0
      dbf   d3,.loopY
      
      movem.l (sp)+,d2-d6/a2-a3
      clr.l d0
      clr.l d1
      rts

; ------------------------------------------------
; DrawTileLine (C interface)
; IN: (long) ptr to tilemap
;     (long) ptr to tileset
_DrawTileLine::
      move.l  4(sp),gputilemapptr 
      move.l  8(sp),gputilesptr
            
      lea gpusem,a0
      move.l  #2,(a0)
  
      rts
      
  
; ------------------------------------------------
; DrawTunnel (C interface)
; IN: (long) ptr to texture
;     (long) LUT Y offset
;     (long) ptr to video memory
_DrawTunnel:: 
      move.l  4(sp),a1
      move.l  8(sp),d0
      move.l  12(sp),d1
      
      move.l  a1,gpuscrollmapbase
      move.l  d0,gpuLUTYoffset
      move.l  d1,gupptrvidmem
      
      lea gpusem,a0
      move.l  #1,(a0)
        
      rts
      
; ------------------------------------------------
; GPU (C interface)
; Only call this after requesting a task to the GPU
_GPUsync::   
      lea gpusem,a0  
.testgpudone:
      stop #$2000   
      move.l  (a0),d0 ; Test when GPU is done
      cmpi.b  #31,d0
      bne.s .testgpudone   
      rts
   
; ------------------------------------------------
; LoadCLUT (C interface)
; Load color LUT from pal8 image
; IN: (long) ptr to pal8 image
; IN: (long) number of colors
_LoadCLUT::
      move.l 4(sp),a0
      move.l 8(sp),d1
      lea CLUT,a1
      subq.w  #1,d1      
.loop:
      move.w  (a0)+,(a1)+
      dbf d1,.loop
      rts 
      
; -------------------------------------------------------
; Data
; -------------------------------------------------------      

		.data
		.long
_systemtype:  .dc.l 0
_tracks_number: .dc.l TRACK_NUMBER
_tracks:
    ; Noob track
     .dc.l noobtrackbitmap
      .dc.l noobtrackbitmapend
      .dc.l tileset_7
      .dc.l noobtrackname
      .dc.l 59999
      .dc.l 0
      .dc.l 0
    ; Test track data
      .dc.l trackbitmap
      .dc.l trackbitmapend
      .dc.l tileset_7
      .dc.l testtrackname
      .dc.l 59999
      .dc.l 0
      .dc.l 0
    ; Nice track data
      .dc.l nicetrackbitmap
      .dc.l nicetrackbitmapend
      .dc.l tileset_7
      .dc.l nicetrackname
      .dc.l 59999
      .dc.l 0
      .dc.l 0
    ; Rama track data
      .dc.l ramatrackbitmap
      .dc.l ramatrackbitmapend
      .dc.l tileset_5
      .dc.l ramatrackname
      .dc.l 59999
      .dc.l 0
      .dc.l 0
    ; Daedalus track data
      .dc.l dedaletrackbitmap
      .dc.l dedaletrackbitmapend
      .dc.l tileset_5
      .dc.l dedaletrackname
      .dc.l 59999  
      .dc.l 0  
      .dc.l 0
    ; Cygnus track data
      .dc.l cygnustrackbitmap
      .dc.l cygnustrackbitmapend
      .dc.l tileset_5
      .dc.l cygnustrackname
      .dc.l 59999  
      .dc.l 0      
      .dc.l 0  
    ; Cave track data
      .dc.l racetrackbitmap
      .dc.l racetrackbitmapend
      .dc.l tileset_6
      .dc.l racetrackname
      .dc.l 59999  
      .dc.l 0  
      .dc.l 0
    ; Speed track data
      .dc.l speedtrackbitmap
      .dc.l speedtrackbitmapend
      .dc.l tileset_6
      .dc.l speedtrackname
      .dc.l 59999  
      .dc.l 0
      .dc.l 0
    ; BBQ track data
      .dc.l bbqtrackbitmap
      .dc.l bbqtrackbitmapend
      .dc.l tileset_6
      .dc.l bbqtrackname
      .dc.l 750
      .dc.l 0
      .dc.l 0
    ; Space ship track data
      .dc.l spaceshipbitmap
      .dc.l spaceshipbitmapend
      .dc.l tileset_2
      .dc.l spaceshiptrackname
      .dc.l 59999
      .dc.l 0
      .dc.l 0
    ; Space ship 3 track data
      .dc.l spaceship3bitmap
      .dc.l spaceship3bitmapend
      .dc.l tileset_2
      .dc.l spaceship3trackname
      .dc.l 59999   
      .dc.l 0
      .dc.l 0    
    ; Space ship 2 track data
      .dc.l spaceship2bitmap
      .dc.l spaceship2bitmapend
      .dc.l tileset_2
      .dc.l spaceship2trackname
      .dc.l 650 
      .dc.l 0     
      .dc.l 0
    ; Plasma track data
      .dc.l plasmatrackbitmap
      .dc.l plasmatrackbitmapend
      .dc.l tileset_4 
      .dc.l plasmatrackname
      .dc.l 59999 
      .dc.l 0  
      .dc.l 0              
    ; Plasma track data
      .dc.l plasma2trackbitmap
      .dc.l plasma2trackbitmapend
      .dc.l tileset_4 
      .dc.l plasma2trackname
      .dc.l 59999 
      .dc.l 0 
      .dc.l 0 
    ; Plasma track data
      .dc.l plasma3trackbitmap
      .dc.l plasma3trackbitmapend
      .dc.l tileset_4 
      .dc.l plasma3trackname
      .dc.l 650 
      .dc.l 0
      .dc.l 0
    ; Rama 2 track data
      .dc.l rama2trackbitmap
      .dc.l rama2trackbitmapend
      .dc.l tileset_9 
      .dc.l rama2trackname
      .dc.l 59999 
      .dc.l 0
      .dc.l 0    
    ; Lava tube track data
      .dc.l lavatubetrackbitmap
      .dc.l lavatubetrackbitmapend
      .dc.l tileset_3 
      .dc.l lavatubetrackname
      .dc.l 59999 
      .dc.l 0
      .dc.l 0                   
    ; Core track data
      .dc.l coretrackbitmap
      .dc.l coretrackbitmapend
      .dc.l tileset_10
      .dc.l coretrackname
      .dc.l 711 
      .dc.l 0
      .dc.l 0   
               
noobtrackname:  .dc.b "Noobs",0
      .even
testtrackname:  .dc.b "Alpha",0
      .even
nicetrackname:  .dc.b "Zen",0
      .even
ramatrackname:  .dc.b "Rama",0
      .even
dedaletrackname:  .dc.b "Daedalus",0
      .even
cygnustrackname:  .dc.b "Cygnus",0
      .even      
racetrackname:  .dc.b "Cave",0
      .even     
speedtrackname:  .dc.b "Speed",0
      .even         
bbqtrackname:  .dc.b "BBQ",0
      .even  
spaceshiptrackname: .dc.b "Nux Vomica",0
      .even
spaceship2trackname: .dc.b "Derelict",0
      .even
spaceship3trackname: .dc.b "Autopilot",0
      .even      
plasmatrackname:  .dc.b "Plasma",0
      .even
plasma2trackname:  .dc.b "Voltage",0
      .even
plasma3trackname:  .dc.b "Grid",0
      .even
rama2trackname:     .dc.b "Rama 2",0
      .even
lavatubetrackname:  .dc.b "Lava tube",0
      .even
coretrackname:     .dc.b "Core",0
      .even      
                                  
		.dphrase
_font8x8_8b:  .incbin "font8x8_8.raw8"


tileset_2:  .incbin "tracks/tiles/tiles02-2.pal8"
tileset_3:  .incbin "tracks/tiles/tiles03-2.pal8"
tileset_4:  .incbin "tracks/tiles/tiles04-2.pal8"
tileset_5:  .incbin "tracks/tiles/tiles05.pal8"
tileset_6:  .incbin "tracks/tiles/tiles06.pal8"
_menutiles:
tileset_7:  .incbin "tracks/tiles/tiles07.pal8"
tileset_8:  .incbin "tracks/tiles/tiles08.pal8"
tileset_9:  .incbin "tracks/tiles/tiles09-2.pal8"
tileset_10:  .incbin "tracks/tiles/tiles10-2.pal8"
_menumap:   .incbin "tracks/menumap.bmp"

noobtrackbitmap:  .incbin "tracks/noobtrack.bmp"
noobtrackbitmapend:
trackbitmap: .incbin "tracks/track3.bmp"
trackbitmapend:
nicetrackbitmap:  .incbin "tracks/nicetrack.bmp"
nicetrackbitmapend:  
ramatrackbitmap:  .incbin "tracks/ramatrackb.bmp"
ramatrackbitmapend: 
dedaletrackbitmap:  .incbin "tracks/dedale.bmp"
dedaletrackbitmapend:
cygnustrackbitmap:  .incbin "tracks/cygnus.bmp"
cygnustrackbitmapend:
racetrackbitmap:  .incbin "tracks/racetrack.bmp"
racetrackbitmapend:
speedtrackbitmap: .incbin "tracks/racetrack2.bmp"
speedtrackbitmapend:
bbqtrackbitmap:   .incbin "tracks/racetrack3.bmp"
bbqtrackbitmapend:
spaceshipbitmap:    .incbin "tracks/spaceship.bmp"
spaceshipbitmapend:
spaceship2bitmap:    .incbin "tracks/spaceship2.bmp"
spaceship2bitmapend:
spaceship3bitmap:    .incbin "tracks/spaceship3.bmp"
spaceship3bitmapend:
plasmatrackbitmap:  .incbin "tracks/plasma.bmp"
plasmatrackbitmapend:
plasma2trackbitmap:  .incbin "tracks/plasma2.bmp"
plasma2trackbitmapend:
plasma3trackbitmap:  .incbin "tracks/plasma3.bmp"
plasma3trackbitmapend:
rama2trackbitmap:   .incbin "tracks/rama2.bmp"
rama2trackbitmapend:
lavatubetrackbitmap:   .incbin "tracks/lavatube2.bmp"
lavatubetrackbitmapend:
coretrackbitmap:   .incbin "tracks/core.bmp"
coretrackbitmapend:

    .dphrase
_titlebitmap: .incbin "data/tube_se.rgb"
_shipbitmap:  .incbin "data/ship_3_thrust_on.rgb"
_shipthrustoffbitmap:  .incbin "data/ship_3_thrust_off.rgb"
_shipkillbitmap:  .incbin "data/ship_3_kill.rgb"
_lutdata:     .incbin "data/lut.dat"
_lutleftdata: .incbin "data/lutleft.dat"
_lutrightdata: .incbin "data/lutright.dat"
_pallutdata:     .incbin "data/lutpal.dat"
_pallutleftdata: .incbin "data/lutleftpal.dat"
_pallutrightdata: .incbin "data/lutrightpal.dat"
_masktunnel: .incbin "data/mask.pal8"
_U235SElogo:  .incbin "data/U-235SE192.rgb"
_endbitmap:   .incbin "data/ending.rgb"

          .long
_module:  .incbin "data/TubeTitle002.mod"   
          .long
_ingamemod1:  .incbin "data/game01.mod"
          .long
_ingamemod2:  .incbin "data/game02.mod"
          .long
_ingamemod3:  .incbin "data/game03.mod"
          .phrase
_endmod:      .incbin "data/ending2.mod"


        .even
_jetsound:     .incbin "sounds/JETENGIN.WAV"
_jetsoundend:
_crashsound:    .incbin "sounds/CRASH8.WAV"
_crashsoundend:
_jaguarsound:   .incbin "sounds/jaguars.wav"
_jaguarsoundend:
_electricsound: .incbin "sounds/electric2.wav"
_electricsoundend:
_blanksound:  .dcb.l  0,256
_blanksoundend:

    .bss
    .dphrase
_vidmem:  .ds.b  160*100
_tunnelmem: .ds.b  TUNNELW*TUNNELHPAL
_tunnelmem2: .ds.b  TUNNELW*TUNNELHPAL
_scrollmap:  .ds.b  SCROLLMAP_W*SCROLLMAP_H*2


  .end      