#include "graphics.h"
#include "JAGUAR.H"
#include "game.h"

int FBH;
extern int nbUnlockedTrack;

void Intro();

#define MAX_MODS 3

int* mods[MAX_MODS];

void __main(void) 
{
  int modsel = 0;
  int endscreenDisplayed = 0;
  
  systemtype = GetSystemType();
  if(systemtype)
  {
    FBH = FBH_NTSC; /* NTSC */
  }
  else
  {
    FBH = FBH_PAL; /* PAL */
  }
  
  mods[0] = &ingamemod1;
  mods[1] = &ingamemod2;
  mods[2] = &ingamemod3;
  
  
#pragma dontwarn 80
  SetSampleWithLoop(JET_SND, &jetsound+0x4E, &jetsoundend-2, &jetsound+0x4E);
  SetSample(CRASH_SND, &crashsound+0x4E, &crashsoundend-2);
  SetSample(JAGUAR_SND, &jaguarsound+0x4E, &jaguarsoundend-96);
  SetSample(ELECTRIC_SND, &electricsound+0x4E, &electricsoundend-96);  
  SetSample(BLANK_SND, &blanksound, &blanksoundend -4);
#pragma popwarn
  ChangeSampleSign(JET_SND);
  ChangeSampleSign(JAGUAR_SND);
  ChangeSampleSign(ELECTRIC_SND);  
  Intro();
  
	InitModule(&module);
#ifdef BENCHMARK
   /*PlayModule();*/
#else
  PlayModule();
#endif
  for(;;)
  { 
    int sel = MenuLoop();
    if(sel == 42)
    {
      StopModule();
      PlaySampleAllChan(BLANK_SND);
      InitModule(&endmod);
      PlayModule();
      Outtro();
      StopModule();
      PlaySampleAllChan(BLANK_SND);
      InitModule(&module);
	    PlayModule();
	    endscreenDisplayed = -1;
    }
    else if(sel<nbUnlockedTrack)
    {
      StopModule();
      PlaySampleAllChan(BLANK_SND);
      InitModule(mods[modsel]);
      GameLoop(sel);      
      StopModule();
      PlaySampleAllChan(BLANK_SND);
      modsel++;
      if(modsel>=MAX_MODS) modsel = 0;
      if(!endscreenDisplayed)
      {
#define TRACKS_TO_UNLOCK  18
        int i;
        int unlockedTrack = 0;
        CTrackInfo* trackarray = &tracks;
        for(i = 0; i<TRACKS_TO_UNLOCK; i++)
        {
          if(trackarray[i].mUnlocked)
            unlockedTrack++;
        }
        if(unlockedTrack == TRACKS_TO_UNLOCK)
        {
          InitModule(&endmod);
          PlayModule();
          Outtro();
          StopModule();
          PlaySampleAllChan(BLANK_SND);
    	    endscreenDisplayed = -1;      
        }
      }
	    InitModule(&module);
	    PlayModule();
    }   
  }
}


extern unsigned short U235SElogo;
#define LOGO_W 192
#define LOGO_H  75

void Intro()
{
static CBitmap introBitmaps[1];
static CBitmapArray introArray;
static char listbuff[DLSIZE(1)+32+16];
static char* ptlist;
  int tick_start;
  int end = 0;  
  int waittime = 0;
  ptlist = ALIGN(listbuff);
  MakeBitmap(&introBitmaps[0], &U235SElogo,(FBW-LOGO_W)/2,(FBH-LOGO_H)>>1,LOGO_W,LOGO_H,0);
  InitBitmapArray(&introArray, ptlist, &introBitmaps[0], 1);  
	ActiveBitmapArray = &introArray;

 
  tick_start = ticks;  
	SetFreq(4, 20000);
	SetFreq(5, 20000);
	SetVol(4,64);
	SetVol(5,64);
	PlaySampleDoubleChan(4,JAGUAR_SND);
	if(systemtype)
	{
	   waittime = 3*43;
  }
  else
  {
    waittime = 3*36;
  }
  
	while(!end)
	{
	  WaitVBL();
    if((ticks-tick_start)>waittime) end = -1;
  }
}


