
	.include    "jaguar.inc"
	.include    "graphics.inc"
	
; -------------------------------------------------------
; Default frame buffer size
; -------------------------------------------------------
BMP_WIDTH   	.equ    320     ; Width in Pixels
BMP_HEIGHT  	.equ    200     ; Height in Pixels
BMP_HEIGHT_PAL .equ    232     ; Height in Pixels


; -------------------------------------------------------
; Externals
; -------------------------------------------------------
		.extern	___main
		.extern gpucode
    .extern startgpucode
    .extern gpuinit
    .extern endgpucode 
    .extern GameVideoIT

    
; -------------------------------------------------------
; Entry point
; -------------------------------------------------------		
		.text
		.68000

	move.l  #INITSTACK,a7   	; Setup a stack
  move.l	#0,G_FLAGS	; Init GPU
  move.l	#0,D_FLAGS	; Init DSP
  move.l  #$70007,G_END		; big-endian mode
  move.l  #$70007,D_END            	

	jsr    LoadGPUCode
	
	move.l #startgpucode,d0
	move.l #gpuinit,d1
	sub.l  d0,d1
	add.l  #G_RAM,d1
	move.l  d1,G_PC
  move.l  #GPUGO,G_CTRL  

  	move.w  CONFIG,d2      		 ; Also is joystick register
  	andi.w  #VIDTYPE,d2    		 ; 0 = PAL, 1 = NTSC
  	lsr.l  #4,d2
  	tst.w  d2
  	beq.s .palsystem
  	move.l  #BMP_HEIGHT,d1
  	bra.s  .callinitjaguar
.palsystem:
    move.l  #BMP_HEIGHT_PAL,d1 
.callinitjaguar:
	move.l  #BMP_WIDTH,d0		
  move.l  #RGB16,d2
  move.l  #GameVideoIT,d3	
	jsr    InitJaguar	
	
  move.w  #0,BG
  
  ; Default LUT
  move.w  #0,CLUT
  move.w  #(31<<11)|32,CLUT+2 ; orange
  move.w  #(31<<6),CLUT+4 ; blue
  move.w  #(8<<11)|(8<<6)|16,CLUT+6 ; dark grey
  move.w  #(24<<11)|(24<<6)|48,CLUT+8 ; light grey
  move.w  #(31<<11),CLUT+10  ; red
  move.w  #63,CLUT+12  ; green
  move.w  #(31<<11)|(31<<6),CLUT+14  ; pink
  
	jmp 	___main			; Jump to main code



; ------------------------------------------------
;  Load GPU code into GPU RAM
LoadGPUCode:
    movem.l d0-d1/a0-a1,-(sp)
   	lea	gpucode,a0		; Get the address of the GPU code in ROM
		lea	startgpucode,a1	; Get destination address
		move.l	#endgpucode,d0		; and calculate length of GPU code
		sub.l	#startgpucode,d0
    asr.l #2,d0
    clr.l   d1    
    
    adda.l  #$8000,a1  ; GPU RAM 32 bit write access
    move.l  #PITCH1|PIXEL32|XADDPHR,A2_FLAGS
    move.l  a0,A2_BASE
    move.l  d1,A2_PIXEL     
    move.l  #PITCH1|PIXEL32|XADDPHR,A1_FLAGS
    move.l  a1,A1_BASE
    move.l  d1,A1_PIXEL
    or.l    #(1<<16),d0
    move.l  d0,B_COUNT
    move.l  #SRCEN|LFU_REPLACE,B_CMD
    movem.l (sp)+,d0-d1/a0-a1
    rts

		.end
